---
title: Create Resource
description: The POST {{apiPath}}/v1/environments/{{envID}}/resources operation adds a custom resource to the specified environment. Only custom resources can be created.
component: pingone-api
page_id: pingone-api:platform:resources/resources-1/create-resource
canonical_url: https://developer.pingidentity.com/pingone-api/platform/resources/resources-1/create-resource.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create Resource

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/resources
```

The `POST {{apiPath}}/v1/environments/{{envID}}/resources` operation adds a custom resource to the specified environment. Only custom resources can be created.

The request body must specify a value for the custom resource `name` property, and the `name` value must be unique within the specified environment. If a value for the `accessTokenValiditySeconds` property is not specified, the new custom resource uses the default value of 3600 seconds. If a value for the `audience` property is not specified, the value defaults to the name of the custom resource.

|   |                                                                                                       |
| - | ----------------------------------------------------------------------------------------------------- |
|   | For new custom resources, the `sub` claim is created separately and its value is set to `${user.id}`. |

### Prerequisites

* Refer to [Resources](../../resources.html) for important overview information.

> **Collapse: Request Model**
>
> | Property                                      | Type    | Required? |
> | --------------------------------------------- | ------- | --------- |
> | `accessTokenValiditySeconds`                  | Integer | Required  |
> | `applicationPermissionsSettings.claimEnabled` | Boolean | Optional  |
> | `audience`                                    | String  | Required  |
> | `description`                                 | String  | Optional  |
> | `name`                                        | String  | Required  |
> | `required`                                    | String  | Optional  |
>
> Refer to the [Resources data model](../../resources.html) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
        "claimEnabled": true
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/resources' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
        "claimEnabled": true
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/resources")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""name"": ""CustomResource{{$timestamp}}""," + "\n" +
@"    ""description"": ""This is my custom resource""," + "\n" +
@"    ""audience"": ""https://api.customresource{{$timestamp}}.com""," + "\n" +
@"    ""accessTokenValiditySeconds"": 7200," + "\n" +
@"    ""applicationPermissionsSettings"": {" + "\n" +
@"        ""claimEnabled"": true" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/resources"
  method := "POST"

  payload := strings.NewReader(`{
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
        "claimEnabled": true
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/resources HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
        "claimEnabled": true
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"name\": \"CustomResource{{$timestamp}}\",\n    \"description\": \"This is my custom resource\",\n    \"audience\": \"https://api.customresource{{$timestamp}}.com\",\n    \"accessTokenValiditySeconds\": 7200,\n    \"applicationPermissionsSettings\": {\n        \"claimEnabled\": true\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/resources")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/resources",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
      "claimEnabled": true
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/resources',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "name": "CustomResource{{$timestamp}}",
    "description": "This is my custom resource",
    "audience": "https://api.customresource{{$timestamp}}.com",
    "accessTokenValiditySeconds": 7200,
    "applicationPermissionsSettings": {
      "claimEnabled": true
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/resources"

payload = json.dumps({
  "name": "CustomResource{{$timestamp}}",
  "description": "This is my custom resource",
  "audience": "https://api.customresource{{$timestamp}}.com",
  "accessTokenValiditySeconds": 7200,
  "applicationPermissionsSettings": {
    "claimEnabled": True
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/resources');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "name": "CustomResource{{$timestamp}}",\n    "description": "This is my custom resource",\n    "audience": "https://api.customresource{{$timestamp}}.com",\n    "accessTokenValiditySeconds": 7200,\n    "applicationPermissionsSettings": {\n        "claimEnabled": true\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/resources")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "name": "CustomResource{{\$timestamp}}",
  "description": "This is my custom resource",
  "audience": "https://api.customresource{{\$timestamp}}.com",
  "accessTokenValiditySeconds": 7200,
  "applicationPermissionsSettings": {
    "claimEnabled": true
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"name\": \"CustomResource{{$timestamp}}\",\n    \"description\": \"This is my custom resource\",\n    \"audience\": \"https://api.customresource{{$timestamp}}.com\",\n    \"accessTokenValiditySeconds\": 7200,\n    \"applicationPermissionsSettings\": {\n        \"claimEnabled\": true\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/resources")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/9fd86709-4faf-4b59-b789-f46574ffb566"
        },
        "environment": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "scopes": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/9fd86709-4faf-4b59-b789-f46574ffb566/scopes"
        },
        "attributes": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/9fd86709-4faf-4b59-b789-f46574ffb566/attributes"
        },
        "secret": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/resources/9fd86709-4faf-4b59-b789-f46574ffb566/secret"
        }
    },
    "id": "9fd86709-4faf-4b59-b789-f46574ffb566",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "name": "CustomResource1709685712",
    "type": "CUSTOM",
    "audience": "https://api.customresource1709685712.com",
    "description": "This is my custom resource",
    "createdAt": "2024-03-06T00:41:52.636Z",
    "updatedAt": "2024-03-06T00:41:52.636Z",
    "accessTokenValiditySeconds": 7200,
    "introspectEndpointAuthMethod": "CLIENT_SECRET_BASIC",
    "applicationPermissionsSettings": {
        "claimEnabled": true
    }
}
```
